/*
Attention : l'accès simultanée à la mémoire partagée doit être sécurisé par l'utilisation d'un mutex par exemple.
*/

#include <windows.h>
#include <stdio.h>

#define NOM_MEM_PARTAGEE "NomMemoirePartagee"
#define TAILLE_MEM 50

int main(void)
{
   HANDLE hMem; // handle pour la gestion de la mémoire
   char* ptrDonnees; // Données de la mémoire partagée
   int i;

   printf("Attente ... Appuyez sur une touche pour continuer\n");      
   getchar();
   
   // Création d'une zone de mémoire partagée pour les échanges
   hMem = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, NOM_MEM_PARTAGEE);

   // Création d'une vue dans cette mémoire partagée des 20 premiers caractères
   ptrDonnees = (char*)MapViewOfFile(hMem, FILE_MAP_ALL_ACCESS, 0, 0, 26);

   printf("Consommateur : lit la memoire partagee\n");
   for(i=0;i<26;i++)
      printf("%c ", *(ptrDonnees+i));

   // Libération de la mémoire partagée
   UnmapViewOfFile(ptrDonnees);

   CloseHandle(hMem);
   
   return 0;
}
