/*
Processus créateur : ce processus crée le mutex et l'utilise
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

void P(HANDLE hMutex)
{
   WaitForSingleObject(hMutex, INFINITE);
}

void V(HANDLE hMutex)
{
   ReleaseMutex(hMutex);
}

void travail(int i)
{
   int simulationTravail = 1000 + (int)((double)rand() * (i+100) / (RAND_MAX+1.0));
   printf("la tache%d travaille pendant %.2f s ...\n", i, (float)(simulationTravail/1000.0));
   Sleep(simulationTravail);
   printf("la tache%d a fini son travail ...\n", i);
}

int main(void)
{
   HANDLE hMutex;

   srand(time(NULL)); //pour la simulation

   hMutex = CreateMutex(
                        NULL, // descripteur de sécurité par défaut
                        FALSE, // mutex not owned
                        TEXT("NameOfMutexObject")); // nom de l'objet

   if (hMutex == NULL)
   {
      printf( "CreateMutex failed (%d).\n", GetLastError());
      ExitProcess(1);
   }

   P(hMutex);
   printf("le processus1 débloque le processus2 ...\n");
   travail(1);
   printf("Attente pour bloquer l'autre processus - Appuyez sur une touche pour débloquer le processus 2\n");
   getchar();
   V(hMutex);

   CloseHandle(hMutex);
   printf("Fin ...\n");

   return 0;
}
