/*
Processus utilisateur seulement : ce processus ouvre le mutex et l'utilise
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

void P(HANDLE hMutex)
{
   WaitForSingleObject(hMutex, INFINITE);
}

void V(HANDLE hMutex)
{
   ReleaseMutex(hMutex);
}

void travail(int i)
{
   int simulationTravail = 1000 + (int)((double)rand() * (i+1000) / (RAND_MAX+1.0));
   printf("la tache%d travaille pendant %.2f s ...\n", i, (float)(simulationTravail/1000.0));
   Sleep(simulationTravail);
   printf("la tache%d a fini son travail ...\n", i);
}

int main(void)
{
   HANDLE hMutex;

   srand(time(NULL)); //pour la simulation

   hMutex = OpenMutex(
                      MUTEX_ALL_ACCESS, // Accès complet
                      FALSE, // handle not inheritable
                      TEXT("NameOfMutexObject")); // nom de l'objet

   if (hMutex == NULL)
   {
      printf( "CreateMutex failed (%d).\n", GetLastError() );
      ExitProcess(1);
   }

   printf("le processus2 attend le processus1 ...\n");
   P(hMutex);
   travail(2);   
   V(hMutex);

   CloseHandle(hMutex);
   printf("Fin ...\n");

   return 0;
} 
